package me.totalfreedom.totalfreedommod.perms;

import me.totalfreedom.totalfreedommod.util.FLog;
import net.luckperms.api.model.group.Group;
import net.luckperms.api.model.group.GroupManager;

public class GroupWrapper
{
    private final GroupManager manager;

    public GroupWrapper(GroupManager manager)
    {
        this.manager = manager;
    }

    public Group getGroup(String name)
    {
        if (!manager.isLoaded(name))
        {
            return manager.createAndLoadGroup(name).join();
        }

        return manager.getGroup(name);
    }

    public void saveGroup(String name)
    {
        Group group = getGroup(name);
        manager.saveGroup(group)
                .thenRun(() ->
                        FLog.info("Saved group " + name + " to LuckPerms."));
    }
}
