package me.totalfreedom.totalfreedommod.perms;

import me.totalfreedom.totalfreedommod.util.FLog;
import net.luckperms.api.track.Track;
import net.luckperms.api.track.TrackManager;

public class TrackWrapper
{
    private final TrackManager manager;

    public TrackWrapper(TrackManager manager)
    {
        this.manager = manager;
    }

    public Track getTrack(String name)
    {
        if (!manager.isLoaded(name))
        {
            return manager.createAndLoadTrack(name).join();
        }

        return manager.getTrack(name);
    }

    public void saveTrack(String name)
    {
        Track t = getTrack(name);
        manager.saveTrack(t)
                .thenRun(() ->
                        FLog.info("Saved track " + name + " successfully."));
    }
}
