package me.totalfreedom.totalfreedommod.perms;

import net.luckperms.api.LuckPermsProvider;
import net.luckperms.api.cacheddata.CachedDataManager;
import net.luckperms.api.cacheddata.CachedMetaData;
import net.luckperms.api.cacheddata.CachedPermissionData;
import net.luckperms.api.context.ImmutableContextSet;
import net.luckperms.api.model.user.User;
import net.luckperms.api.platform.PlayerAdapter;
import net.luckperms.api.query.QueryOptions;
import org.bukkit.entity.Player;

/**
 * This class is a utility class that can be used to retrieve
 * numerous contextual options related to LuckPerms users.
 */
public class UserData
{
    public static User fromPlayer(Player player)
    {
        PlayerAdapter<Player> adapter = LuckPermsProvider
                .get()
                .getPlayerAdapter(Player.class);
        return adapter.getUser(player);
    }

    public static QueryOptions getQueryOptions(User user)
    {
        return user.getQueryOptions();
    }

    public static CachedDataManager getDataManager(User user)
    {
        return user.getCachedData();
    }

    public static ImmutableContextSet getContextSet(User user)
    {
        return getQueryOptions(user).context();
    }

    public static CachedMetaData getMetaData(User user)
    {
        return getDataManager(user).getMetaData();
    }

    public static CachedPermissionData getPermissionData(User user)
    {
        return getDataManager(user).getPermissionData();
    }
}
